{$i-}
program domino_sort;

uses
  crt, gfx; {gfx initialisiert hier den 640x480x16 Graphikmodus}

const
  {
    Definition der Richtungskonstanten;
    die Werte sind die Offsets zum nchsten Stein,
    der in der jeweiligen RIchtung liegt
  }
  horizontal = 2;
  vertical   = 1;

  {Aktuelle Suchrichtung; pos + direction ist der nchste Stein in stones[]}
  direction : byte = vertical;

  {Position in stones[]; 0 ist oben links, 55 ist unten rechts}
  pos : byte = 0;

var
  {stones[] enthlt die 56 Ziffern der Zeichnung}
  stones : array[0..55] of byte;

  {
    stones_used[a][b] ist TRUE, wenn der Stein mit den Ziffern (a | b)
    bereits verwendet wurde
  }
  stones_used : array[0..6, 0..6] of boolean;

{
  Lade Domino-Augenzahlen aus "domino.dat";
  setze stones_used[] zurck
}
procedure init;
var
  f : text;
  i, j : byte;
  temp : char;
begin
  {
    Versuche, die Datei "domino.dat" zu ffnen;
    falls dabei ein Fehler auftritt,
    beende das Programm mit einer Fehlermeldung
  }
  assign(f, 'domino.dat');
  reset(f);
  if ioresult <> 0 then begin
    writeln('Die Datei "domino.dat" wurde nicht gefunden!');
    writeln('Drcken Sie die Eingabetaste, um das Programm zu beenden');
    readln;
    halt;
  end;

  {
    Lese die Domino-Augenzahlen aus der Datei "domino.dat"
    in stones[] ein, und schliesse die Datei
  }
  for i := 0 to 55 do begin
    read(f, temp);
    stones[i] := ord(temp) - ord('0');
  end;
  close(f);

  {Gebe Peter Pingels Zeichnung aus}
  for i := 0 to 55 do begin
    gotoxy(4 * (i mod 8) + 3, 2 * (i div 8) + 2);
    write(stones[i]);
  end;
  rect(4, 8, 33 * 8 - 4, 15 * 16 - 8, $0f0f);

  gotoxy(40, 2);
  writeln('Domino-Sortierer v1.1');
end;

{Speichere die Richtung des aktuellen Steins in direction}
procedure get_stone;
var
  a, b : byte;
begin
  {Lese die beiden nchsten Ziffern aus der Zeichnung}
  a := stones[pos];
  if direction = horizontal then
    b := stones[pos + 1]
  else
    b := stones[pos + 8];
  {(a | b) sind die Ziffern des aktuellen Steins}

  {
    Prfe, ob die Zifferkombination (a | b)
    bereits in einem anderen Stein vorkam;
    falls ja, wechsle die Richtung
  }
  if stones_used[a][b] then
    direction := horizontal + vertical - direction
  else
    stones_used[a][b] := true;
end;

{Zeichne den Umriss des aktuellen Domino-Steins}
procedure draw_stone;
var
  x, y : byte;
begin
  x := 8 * (4 * (pos mod 8) + 3); y := 16 * (2 * (pos div 8) + 2);

  if direction = horizontal then
    rect(x - 20, y - 24, x + 44, y + 8, $0f0f)
  else
    rect(x - 20, y - 24, x + 12, y + 40, $0f0f);
end;

{Zum nchsten Domino-Stein in der Zeichnung wechseln}
procedure set_pos;
begin
  {Sonderfall fr vertikale Steine am rechten Rand der Zeichnung}
  if (pos mod 8 = 7) and (direction = vertical) then inc(pos, 8);

  inc(pos, direction);
end;

begin
  init;

  repeat
    get_stone;
    draw_stone;
    set_pos;
  until pos > 55;

  gotoxy(15, 29);
  writeln('Drcken Sie eine Taste, um das Programm zu beenden');
  readkey;
end.