(******************************************************************************)
(*                     BWINF 2000 A2 - FINAL VERSION                          *)
(*    ---------------------------------------------------------------         *)
(*      Lsungsbeispiel zu Aufgabe 2 des Bundeswettbewerbs Informatik         *)
(*                                                                            *)
(*    HAUPTPROGRAMM - Diese Unit enthlt nur die Bedienoberflche !!!         *)
(*    Die Datei BWINF_A2.PAS enthlt das Objekt mit allen Funktionen          *)
(*    fr die Lsung der Aufgabe !!!                                          *)
(*                                                                            *)
(*    Copyleft by  Sebastian Hfer                    ( Oktober 2000 )        *)
(*                                                                            *)
(******************************************************************************)

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ToolWin, ComCtrls, Buttons, ImgList, Explor, BWInf_A2;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    ToolBar1: TToolBar;
    ListBox1: TListBox;
    Feld1: TMenuItem;
    BWInf2000Feld1: TMenuItem;
    N1: TMenuItem;
    Laden1: TMenuItem;
    Speichern1: TMenuItem;
    N2: TMenuItem;
    Beenden1: TMenuItem;
    Extra1: TMenuItem;
    FeldExplorer1: TMenuItem;
    N3: TMenuItem;
    Ergebnisspeichern1: TMenuItem;
    Suche1: TMenuItem;
    Starten1: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton7: TToolButton;
    ToolButton9: TToolButton;
    FeldOpenD: TOpenDialog;
    FeldSaveD: TSaveDialog;
    ResultSaveD: TSaveDialog;
    ImageList1: TImageList;
    Zufallsfllung1: TMenuItem;
    stat: TStatusBar;
    Wegzeichnen1: TMenuItem;
    procedure FeldExplorer1Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BWInf2000Feld1Click(Sender: TObject);
    procedure Laden1Click(Sender: TObject);
    procedure Speichern1Click(Sender: TObject);
    procedure Starten;
    procedure Ergebnisspeichern1Click(Sender: TObject);
    procedure Zufallsfllung1Click(Sender: TObject);
    procedure Wegzeichnen1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    procedure Ausgabe( w:integer; r: TRichtung);
  end;

var
  MainForm: TMainForm;
  Feld : TSpielbrett;

const
  BWINFDAT = 'bwinf2k.dat';  // Datei mit den Zahlen fr den BW Inf !

implementation

{$R *.DFM}

procedure TMainForm.Ausgabe( w:integer; r: TRichtung);
(* bersetzt die Ausgabe der Suchprozedur in Textform *)
const pp : array[TRichtung] of string[2] = ('NO','O','SO','SW','W','NW');
var s, plural : string;
begin
  if w > 1 then plural:= ' Felder ' else plural:= ' Feld ';
  case w of
   ERREICHT : begin s := 'Ausgangspunkt erreicht !'; FExplor.AddJump(0,NO); end;
   WEGGEFUNDEN : begin s := 'Weg gefunden:'; {FExplor.AddJump(0,NO);} end;
   KEINWEG  : begin s := 'Es konnte kein Weg gefunden werden !'; FExplor.AddJump(0,NO); end;
  else
   begin
    s := 'Sprung: '+inttostr( w )+plural+'nach '+pp[R];
    if wegzeichnen1.Checked then FExplor.DrawLine( w, r );  // Linie zeichnen
    FExplor.AddJump( w, r );     // Sprung zur Liste hinzufgen
   end; end;
  Listbox1.Items.Insert( 0, s );  // Text ausgeben
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Feld := TSpielbrett.create( Ausgabe );  // Feld erstellen
  FExplor := TFExplor.Create( MainForm ); // Fenster des "FeldExplorer" erstellen
  FExplor.proot := Feld.root;             // Startfeld an "FeldExplorer" bergeben
  FExplor.Visible := true;                // "FeldExplorer" sichtbar machen
  stat.Panels[0].Text := 'Feld aufgebaut !';
  BWInf2000Feld1Click(Sender);            // BWInfFeld laden und Suche starten
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Feld.destroy; // Feld beim Beenden wieder abbauen !
end;

procedure TMainForm.Beenden1Click(Sender: TObject);
begin Close; end;

procedure TMainForm.FeldExplorer1Click(Sender: TObject);
begin
  with FeldExplorer1 do begin
   FExplor.Visible := not FExplor.Visible;
   Checked := FExplor.Visible;
  end;
end;

procedure TMainForm.BWInf2000Feld1Click(Sender: TObject);
(* Ldt die Zahlen fr den BWInf aus einer Datei ! *)
begin
  if Fileexists( BWINFDAT ) then
   if not Feld.LoadfromFile( BWINFDAT ) then
    MessageDlg('Fehler beim Laden der Datei '''+BWINFDAT+''' !',mtError,[mbOk],0)
   else begin Fexplor.DrawIt; listbox1.Clear; end
  else MessageDlg('Kann Datei '''+BWINFDAT+''' nicht finden !'+ #10#13 +
        'Die Datei muss sich Programmverzeichnis befinden !',mtError,[mbOk],0);

  stat.Panels[0].Text := 'Zahlen fr den BWInf 2000 Aufg. 2 wurden geladen !';
  Starten;
end;

procedure TMainForm.Zufallsfllung1Click(Sender: TObject);
(* Fllt das Feld mit Zufallszahlen *)
begin
  Feld.Zufallsfuellung;
  Fexplor.DrawIt;
  Listbox1.Clear;
  stat.Panels[0].Text :='Feld wurde mit Zufallszahlen gefllt !';
  Starten;
end;

procedure TMainForm.Laden1Click(Sender: TObject);
(* Ldt ein Feld aus einer Datei *)
begin
  with FeldopenD do begin
   if Execute then if Fileexists(Filename) then
    begin
     if not Feld.LoadfromFile(Filename) then
      MessageDlg('Fehler bei Lesen der Datei '''+Filename+''' !',mtError,[mbOk],0)
     else begin
      listbox1.Clear;
      stat.Panels[0].Text := 'Datei "'+Filename+'" wurde geladen !';
      Starten; end;
    end
   else MessageDlg('Kann Datei '''+Filename+''' nicht finden !',mtError,[mbOk],0)
   else
  Fexplor.DrawIt;
  end;
end;

procedure TMainForm.Speichern1Click(Sender: TObject);
(* Speichert das aktuelle Feld in einer Datei *)
begin
  with FeldsaveD do begin
   if Execute then if Fileexists(Filename) then
    if Messagedlg('Die Datei '''+Filename+''' existiert bereits ! berschreiben ?',
                  mtConfirmation, mbOkCancel, 0 ) <> mrOk then exit
    else
   else else exit;
   if not Feld.SavetoFile( Filename ) then
    MessageDlg('Fehler beim schreiben in '''+Filename+''' !',mtError,[mbOk],0)
   else stat.Panels[0].Text := 'Feld gespeichert !';
  end;
end;

procedure TMainForm.Starten;
begin
  stat.Panels[0].Text := 'Wegsuche ...';
  Listbox1.Clear;        // vorheriges suchergebnis lschen
  Feld.Starte_Suche;     // Suche starten
end;

procedure TMainForm.Ergebnisspeichern1Click(Sender: TObject);
(* Das Ergebnis aus der ListBox wird in eine Datei geschrieben *)
begin
  with ResultsaveD do begin
   if Execute then if Fileexists(Filename) then
    if Messagedlg('Die Datei '''+Filename+''' existiert bereits ! berschreiben ?',
                  mtConfirmation, mbOkCancel, 0 ) <> mrOk then exit
    else
   else else exit;
  try
   Listbox1.Items.SaveToFile(Filename);
   stat.Panels[0].Text := 'Ergebnis gespeichert !';
  except
   MessageDlg('Fehler beim schreiben in '''+Filename+''' !',mtError,[mbOk],0)
  end; end;
end;

procedure TMainForm.Wegzeichnen1Click(Sender: TObject);
(* Menuepunkt, ob der gefundene Weg im "FeldExlporer" angezeigt werden soll ! *)
begin with Wegzeichnen1 do checked := not checked end;

procedure TMainForm.ListBox1Click(Sender: TObject);
begin
  with sender as TListbox do
   if itemindex > -1 then FExplor.DrawJump( itemindex  )
end;

end.
