unit uHasher;

interface

const
  GELOESCHT = false;
  WEITER = true;

type
  ppHashEntry = ^pHashEntry;
  pHashEntry = ^tHashEntry;
  tHashEntry = record
                 Wort  : string;  // Das eigentliche Wort
                 reaktion : boolean;
                 next  : pHashEntry; // nchstes Element in Liste -> fr Hash
                end;

  THashTable = class
    Hashsize : integer;
    Table : array of PHashEntry;
    constructor create(const TableSize: integer );
    destructor KillTable;
    procedure AddEntry(const text: string; reak : boolean);
    function GetEntry(const text: string ): PHashEntry;
  private
    function Hash(str : string) : integer;
  end;


implementation

uses sysutils, dialogs;

constructor THashTable.create(const TableSize: integer );
var i : integer;
begin
  HashSize := TableSize;
  setlength( Table, HashSize );
  for i := 0 to Hashsize-1 do Table[i] := nil;
end;

destructor THashTable.KillTable;
var i : integer;

 procedure KillNode(x : PHashEntry);
 begin
   if x^.next <> nil then KillNode(x^.next);
   dispose( x );
 end;

begin
  for i := 0 to Hashsize-1 do KillNode( Table[i] );
end;

function THAshtable.Hash(str : string) : integer;
var i,h : integer;
begin
 h := 0;
 // Addieren der ASCII codes
 for i := 1 to length(str) do  h := h + ord(upcase(str[i]));
 // Wir wollen sicher sein das der Key innerhalb der Tabelle liegt
 result := (h * 5) mod HashSize; // mal 5 fr bessere Verteilung
end;

procedure THashTable.AddEntry(const text: string; reak : boolean);
Var
  HashAddresse : integer;
  temp, pos    : pHashEntry;


begin
  HashAddresse := Hash( text );
  pos := Table[HashAddresse];
  if pos <> nil then
   begin
    if pos^.Wort = text then
     begin
      pos^.reaktion := reak;
      exit;
     end;
    while pos^.next <> nil do
     begin
      if pos^.Wort = uppercase(text) then
       begin
        pos^.reaktion := reak;
        exit;
       end;
      pos := pos^.next;
     end;
   end
  else
   new(temp);
   temp^.next := nil;
   temp^.Wort := uppercase(text);
   temp^.reaktion := reak;
   if pos = nil then  Table[HashAddresse] := temp
   else pos^.next := temp;
end;

function THashTable.GetEntry(const text: string ): PHashEntry;
begin
  result := Table[ Hash( text ) ];
  while (result <> nil) and (result^.wort <> uppercase(text) ) do
    result := result^.next;
end;

end.
