unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, {eigene -> } uhasher;

type
  (* Eigene Typen *)
  PSMS = ^TSMS; // Pointer auf SMS fr SMSlist
  TSMS = record // Eine SMS besteht aus
           Absender : string[20]; // einem Absender
           Betreff  : string[50]; // einem Betreff
           Inhalt   : string[160]; // dem Inhalt
           Prioritaet : shortint;  // und ihrer Prioritt
         end;

  TPrio = shortint;  // Prioritt

  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    AnzButton: TButton;
    LoeButton: TButton;
    ListBox1: TListBox;
    Image1: TImage;
    WoDalabel: TLabel;
    GroupBox2: TGroupBox;
    AbsEdit: TEdit;
    BetEdit: TEdit;
    InhEdit: TEdit;
    AbsLabel: TLabel;
    BetLabel: TLabel;
    InhLabel: TLabel;
    NeuButton: TButton;
    procedure FormCreate(Sender: TObject); // Beim Erzeugen des Forms
    procedure FormDestroy(Sender: TObject); //Beim Zerstren des Forms
    procedure NeuButtonClick(Sender: TObject);
    procedure AnzButtonClick(Sender: TObject);
    procedure LoeButtonClick(Sender: TObject);
  private
    (* Eigene Prozeduren & Funktionen *)
    // bestimmt Prioritt des Absenders
    function GetAbsenderPrio( name: string): TPrio;
    // bestimmt Prioritt des Betreffs
    function GetBetreffPrio( text: string): TPrio;
    // setzt die Prioritt eines Betreffs
    procedure SetBetreffPrio( text: string; reak : boolean );
    // fgt eine "erhaltene" SMS in die Liste ein
    procedure AddSMS( Abs, Betr, Inh : string );
    // lscht eine SMS aus der Liste
    procedure DeleteSMS( listind : integer );
    // baut die SMS Liste ab
    procedure KillSMSList;
    // schreibt die (unsichtbare) Liste in die sichtbare ListBox
    procedure SMStoList;
    // zeigt den Betreff einer Nachricht in der ListBox an
    procedure ShowBetr( ind : integer );
    // zeigt den Inhalt einer Nachricht in der Listbox an
    procedure ShowInh( ind : integer );
  end;

var
  Form1: TForm1;
  AbsListe, BetrListe : THashTable; // HashTabellen fr Absender und Betreff
  SMSList : TList;             // Liste fr "erhaltene" SMS
  ListStatus : byte;           // Was wird gerade angezeigt? (Siehe const)
  CurrentIndex : integer;      // Position in der Liste (ListBox)

const
  (* ZuStnder der ListBox *)
  ABSENDERLISTE = 1;
  SMSBETREFF = 2;
  SMSINHALT = 3;
  (* Konstanten zu Begrenzung von Variablen *)
  MAXABS = 50; // Maximale Eintrge in der Absender-HashTabelle
  MAXBETREFF = 200; //Maximale Eintrge in der Betreff HashTabelle
implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject); // beim Erzeugen des Forms
begin
  AbsListe  := THashTable.create(MAXABS); // Absender Hash erzeugen
  BetrListe := THashTable.create(MAXBETREFF); // Betreff Hash erzeugen
  SMSList := TList.Create; //Liste fr "erhaltene" SMS erzeugen
  ListStatus := ABSENDERLISTE; // ListBox zeigt Absender aller "erhaltenen" SMS
end;

procedure TForm1.SMStoList; // Schreibt den Inhalt der SMSliste in ListBox
var i : integer;
    s : pSMS;
begin
  Listbox1.Items.Clear; // ListBox leeren
  with SMSList do
   for i:=0 to count - 1 do begin      //
    s := items[i];                     // Alle Absender in Liste schreiben
    Listbox1.Items.Add( s^.Absender ); //
   end;
end;

procedure TForm1.ShowBetr( ind : integer ); // Den Betreff einer Selektierten
var s : pSMS;                               // SMS anzeigen
begin
  Listbox1.items.clear;                     // ListBox leeren
  s := SMSList.Items[ind];                  // markierte Nachricht holen
  Listbox1.items.add( s^.betreff );         // Betreff anzeigen
end;

procedure TForm1.ShowInh( ind : integer ); // Den Inhalt einer SMS anzeigen,
var s : pSMS;                              // von der Vorher der Betreff an-
begin                                      // gezeigt wurde
  Listbox1.items.clear;              // ListBox leeren
  s := SMSList.Items[ind];           // gesuchte SMS holen
  Listbox1.items.add( s^.Inhalt );   // Inhalt anzeigen
end;


procedure TForm1.AddSMS( Abs, Betr, Inh : string ); // Neue SMS in Liste
var ps, ausliste : pSMS;
    prior : tprio;
    i : integer;
begin
  New( ps ); //neue Nachricht
  // Prioritt der Nachricht berechen (Betreff doppelt so wichtig wie Abs)
  prior := GetAbsenderPrio( Abs ) + (GetBetreffPrio( Betr )*2) ;
  // Nachricht fllen
  ps^.Absender := copy(abs,1,20);
  ps^.Betreff := copy(betr,1,50);
  ps^.Inhalt := copy(inh,1,160);
  ps^.Prioritaet := prior;

  with SMSList do begin
   pack;          // nil-zeiger aus liste entfernen !
   if count = 0 then Add( ps ) // wenn Liste leer, SMS eintragen
   else // wenn nicht ..
    begin // of "count<>0"
      i:= 0;
      repeat
       ausliste := items[i];
       inc(i);
      // Liste durchlaufen bis vorhandene SMS niedriger ist als neue
      until (ausliste^.Prioritaet < ps^.Prioritaet) or (i=count);
      if i = count then Add( ps ) // Falls es die letze SMS ist anhngen
      else Insert( i, ps ); // wenn nicht einfgen
    end; // of "count<>0"
  end;
end;

procedure TForm1.DeleteSMS( listind : integer ); // SMS aus Liste lschen
var  s : psms;
begin
  s := SMSList.Items[listind]; //
  SMSList.items.delete( listind );   // SMS holen und lschen
  dispose( s );                //
  SMSlist.pack                 // eventuelle "nil"s entfernen
end;

procedure TForm1.KillSMSList; // Liste Abbauen (sicher ist sicher)
var i : integer;
    s : psms;
begin
  with SMSList do
   for i := 0 to count-1 do  //
   begin                     // Liste von vorne bis hinten durchlaufen
    s := items[i];           // und allen Speicher freigeben
    dispose(s);              //
   end; 
end;

// Prioritt eines Absenders bestimmen
function TForm1.GetAbsenderPrio( name: string): TPrio;
var pE : pHashEntry;
begin
   pE := AbsListe.GetEntry( name ); // Checken ob Abs schon in Hashtabelle
   if  pE = nil then Result := 0  // wenn nicht prio = 0
   else // wenn doch...
    if pE^.reaktion = WEITER then Result := 1 // falls letzesmal SMS gelesen
    else Result := -1;                        // Prio = 1 wenn nicht Prio = -1
end;

// Prioritt eines Betreffs bestimmen
function TForm1.GetBetreffPrio( text: string): TPrio;
var pE : pHashEntry;
    stueck : string; // nimmt Einzelwrter des Betreffs auf
    i : integer;
begin
  for i := 1 to length(text) do
   if text[i] <> ' ' then
    begin
     if upcase(text[i]) in ['A'..'Z'] then
      stueck := stueck + text[i];
    end
   else
    begin
     pE := BetrListe.GetEntry( stueck );
     if  pE <> nil then
      if pE^.reaktion = WEITER then inc(Result)
     else dec(Result);
    stueck := '';
   end;
if stueck <> '' then BetrListe.GetEntry(stueck);
end;

procedure TForm1.SetBetreffPrio( text: string; reak : boolean );
var
    stueck : string;
    i : integer;
begin
  for i := 1 to length(text) do
   if text[i] <> ' ' then
    begin
     stueck := stueck + text[i];
    end
   else
    begin
     BetrListe.AddEntry(stueck, reak);
     stueck := '';
    end;
if stueck <> '' then BetrListe.Addentry(stueck, reak);
end;

procedure TForm1.FormDestroy(Sender: TObject); // beim zerstren des Forms
begin
  AbsListe.Destroy;  // Absender HashTabelle abbauen
  BetrListe.Destroy; // Betreff HashTabelle abbauen
  KillSMSList;       // Liste mit "erhaltenen" SMS abbauen (eigene proc)
  SMSList.Destroy;   // Liste zerstren (Delphi)
end;

procedure TForm1.NeuButtonClick(Sender: TObject);
begin
 AddSMS(AbsEdit.Text,BetEdit.text,InhEdit.text); // SMS hinzufgen
 SMStoList;                                   // ListBox und Liste abgleichen
end;

procedure TForm1.AnzButtonClick(Sender: TObject);
var
 pS : pSMS;
 str : string;
begin
 pS := umain.SMSList.items[currentindex];
 str := pS.Betreff;
 if ( listbox1.itemindex <> -1 ) then // ist was markiert?
  Case ListStatus of  // wo sind wir grade
   ABSENDERLISTE : begin // wir sehen Absender
                    CurrentIndex := listbox1.itemindex;
                    ListStatus := SMSBETREFF;
                    ShowBetr(CurrentIndex);
                    listbox1.ItemIndex := 0; // den Betreff markieren
                   end;

   SMSBETREFF    : begin // wir sehen Betreff einer SMS
                    ListStatus := SMSINHALT;
                    ShowInh(CurrentIndex);
                    SetBetreffPrio(str, WEITER);
                    listbox1.ItemIndex := 0; // den Inhalt markieren
                   end;

   SMSINHALT     : begin // wir sehen Inhalt einer SMS
                    ListStatus := ABSENDERLISTE;
                    SMStoList;
                    listbox1.ItemIndex := -1; // nichts markieren
                   end;
  end; // of CASE
end;

procedure TForm1.LoeButtonClick(Sender: TObject);
begin
 // Falls wir grade die SMS liste zeigen UND etwas ausgewhlt ist...
 if (ListStatus = ABSENDERLISTE) AND (listbox1.itemindex <> -1) then
  begin
   CurrentIndex := listbox1.ItemIndex;
   // ... lschen wir es ...
   DeleteSMS(CurrentIndex);
  end;
 // ... und aktualisieren die Liste
 SMStoList;
end;

end.
