#ifndef __REC_DATA_HPP__
#define __REC_DATA_HPP__

#include <classes.hpp>
#include <sysutils.hpp>

#pragma warn -inl // Unterdrckt Warnung W8026
//---------------------------------------------------------------------------

class REC_DATA
{
	public:
		REC_DATA()
		{
			data = new TStringList;
			pos = 0;
		}

		~REC_DATA()
		{
			data->Free();
		}

		void clear()
		{
			data->Clear();
			pos = 0;
		}

		void reset()
		{
			pos = 0;
		}

		void load(String filename)
		{
			data->LoadFromFile(filename);
		}

		void save(String filename)
		{
			data->SaveToFile(filename);
		}

		void push(String str)
		{
			data->Add(str);
		}

		void pushi(int x)
		{
			push(IntToStr(x));
		}

		String pop()
		{
			// ; Kommentare lschen
			String temp;
			do
			{
				if(pos >= data->Count)
					throw Exception("rec_data-Stack Unterlauf (fehlen Daten vor Dateiende?)");

				temp = data->Strings[pos++]; // Nchste String lesen
				int semi_pos = temp.Pos(";"); // Erste ';' in temp suchen
				if(semi_pos) // Gibt es ein ';'?
					temp.Delete(semi_pos, temp.Length()); // Ja - alles ab dem ';' lschen
			}
			while(!temp.Length()); // Wiederholen, bis eine nicht-Kommentarzeile gelesen
			return temp.LowerCase();
		}

		int popi()
		{
			return StrToInt(pop());
		}

		bool data_avail()
		{
			return data->Count > 0;
		}

		bool at_end()
		{
			return pos >= data->Count;
		}
	private:
		int pos;
		TStringList* data;

};
//---------------------------------------------------------------------------

#endif // #ifndef __REC_DATA_HPP__
